//----------------------------------------------------------------------------------
// aviutlvOC C^Ȓጸ(LPF)
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include <process.h>

#include "filter.h"
#include "lpf_v.h"
#include "mov.h"

//---------------------------------------------------------------------
// ֐
//---------------------------------------------------------------------
static BOOL isSSEusable(void);
unsigned __stdcall thProc(void *);
short *get_motion(FILTER *fp, FILTER_PROC_INFO *fpip);
BOOL malloc_tmp(size_t);
void free_tmp(void);

// Xbhɓnf[^
typedef struct tag_thData
{
  int com;
  int fn;
  PIXEL_YC *dst;
  PIXEL_YC *src;
  union {
    short *m0;
    int ht;
  } arg0;
  union {
    short *m1;
    int hb;
  } arg1;
  int h;
  int w;
  int max_w;
} thData;

//---------------------------------------------------------------------
// O[oϐ
//---------------------------------------------------------------------
// tB^֐
int (*lpf_v[])(PIXEL_YC*, const PIXEL_YC*, int, int, int, int, int)
 = { lpf_v_3,     lpf_v_5,      lpf_v_7,     lpf_v_9,
     lpf_v_11,    lpf_v_13,     lpf_v_15,
     lpf_v_3_mmx, lpf_v_5_mmx,  lpf_v_7_mmx, lpf_v_9_mmx,
     lpf_v_11_mmx,lpf_v_13_mmx, lpf_v_15_mmx };

// o֐
void (*detect_mov[])(const PIXEL_YC*, const PIXEL_YC*, short*, int, int, int, int)
     = { detect_motion, detect_motion_sse };

// uh֐
void (*blend_img[])(PIXEL_YC*, const PIXEL_YC*, const short*, const short*, int, int ,int)
 = { blend_image,     blend_image_min,     blend_image_max,
     blend_image_mmx, blend_image_min_sse, blend_image_max_sse };

// }XN
short *g_tmp0 = NULL;
short *g_tmp1 = NULL;
int g_tmp0_n = -1;
int g_tmp1_n = -1;

// SSELǂ
int g_sse = 0;

// [J[Xbh̃nh
HANDLE g_thr = 0;

// NeBJZNV
CRITICAL_SECTION g_cs;

// Xbhւ̎w
enum COMMAND { WAIT = 0, LPF, BLEND, EXIT };
thData g_thd;

//LARGE_INTEGER g_st,g_ed;

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 4
TCHAR *track_name[] = {"tap", "", "", "" };
int   track_default[] = { 0, 0, 0, 24 };
int   track_s[] = { 0, 0 , 0, 0 };
int   track_e[] = { 6, 64, 64, 256 };
enum  { T_TAP, T_TOP, T_BTM, T_MTH };

#define CHECK_N 5
TCHAR *check_name[]
 = { "MMX/SSE", "̕\", "t[QƂ", "MAX", "}`Xbh" };
int    check_default[] = { 1, 0, 0, 0, 0 };
enum { C_MMX, C_DISP, C_BOTH, C_MAX, C_THR };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  "C^ȒጸA",  //tB^̖O
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,   //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  func_init,   //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  func_exit,   //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  func_update, //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,        //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^
  NULL,NULL,   //VXeŎg܂̂ŎgpȂł
  NULL,        //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,           //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "lpf_decomb by N099, ver1.3.1",
  NULL, NULL,
};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// Ɨ̈̊m
//---------------------------------------------------------------------
BOOL malloc_tmp(size_t sz)
{
  static size_t size = 0;

  if(sz == size && g_tmp0 && g_tmp1){
    return TRUE;
  }
  
  g_tmp0 = _aligned_malloc(sz, 16);
  if(NULL == g_tmp0){
    free_tmp();
    return FALSE;
  }
  
  g_tmp1 = _aligned_malloc(sz, 16);
  if(NULL == g_tmp1){
    free_tmp();
    return FALSE;
  }

  size = sz;

  return TRUE;
}

//---------------------------------------------------------------------
// Ɨ̈̊J
//---------------------------------------------------------------------
void free_tmp()
{
  if(NULL != g_tmp0){
    _aligned_free(g_tmp0);
    g_tmp0 = NULL;
  }

  if(NULL != g_tmp1){
    _aligned_free(g_tmp1);
    g_tmp1 = NULL;
  }
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
  unsigned threadID;

  //SSẼ`FbN
  g_sse =isSSEusable();

  //[J[Xbh̋N
  InitializeCriticalSection(&g_cs);
  EnterCriticalSection(&g_cs);
  ZeroMemory(&g_thd, sizeof(g_thd));
  g_thr = (HANDLE)_beginthreadex(NULL, 0, thProc, &g_thd,
                                 CREATE_SUSPENDED, &threadID);
  
  return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  //Ɨ̈̊J
  free_tmp();

  //Xbh̒~
  if(g_thr){
    g_thd.com = EXIT;
    LeaveCriticalSection(&g_cs);
    ResumeThread(g_thr);
    WaitForSingleObject(g_thr, INFINITE);
    CloseHandle(g_thr);
    g_thr = 0;
  }
  DeleteCriticalSection(&g_cs);

  return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
  
  switch(status){
  case FILTER_UPDATE_STATUS_TRACK + T_MTH:
  case FILTER_UPDATE_STATUS_CHECK + C_MMX:
  case FILTER_UPDATE_STATUS_CHECK + C_THR:
  case FILTER_UPDATE_STATUS_ALL:
    g_tmp0_n = g_tmp1_n = -1;
    break;
  default:
    break;
  }
  
  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int fn_lpf,fn_ble;
  PIXEL_YC *ycp;
  short *pm0, *pm1;
  size_t sz;

  //QueryPerformanceCounter(&g_st);

  //LbV̐ݒ
  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, 3, 0))
    return FALSE;

  //Ɨ̈̊m
  sz = fpip->max_w * (fpip->h * 2 + 2) * sizeof(short);
  if(!malloc_tmp(sz))
    return FALSE;

  //tB^̑I
  fn_lpf  = fp->track[T_TAP];
  fn_lpf += fp->check[C_MMX] * (track_e[T_TAP] + 1);
  
  if(fp->check[C_THR] && fp->track[T_MTH] > 0){
    //}`Xbh and o
    const int h0 = fpip->h/2;
    const int h1 = h0 + (fpip->h & 1);
      
    //LPFʃXbhōs
    g_thd.com = LPF;
    g_thd.fn = fn_lpf;
    g_thd.dst = fpip->ycp_temp;
    g_thd.src = fpip->ycp_edit;
    g_thd.arg0.ht = fp->track[T_TOP];
    g_thd.arg1.hb = fp->track[T_BTM];
    g_thd.h = fpip->h;
    g_thd.w = fpip->w;
    g_thd.max_w = fpip->max_w;
    
    ResumeThread(g_thr);
    LeaveCriticalSection(&g_cs);

    //ʃXbhLPF̏sĂ
    //o
    pm0 = get_motion(fp, fpip);
    
    EnterCriticalSection(&g_cs);

    //{̓Cxg𗘗pđ҂ׂH
    while(g_thd.com == LPF){
      LeaveCriticalSection(&g_cs);
      Sleep(0);
      EnterCriticalSection(&g_cs);
    }

    if(fp->check[C_BOTH]){
      //Ot[Ƃ̔r
      fn_ble = fp->check[C_MAX] + 1 + (fp->check[C_MMX] & g_sse) * 3;
      pm0 = g_tmp0;
      pm1 = g_tmp1;
    }else{
      //Õt[Ƃ̔r
      fn_ble = fp->check[C_MMX] * 3;
      pm1 = NULL;
    }

    //uh̔ʃXbhōs
    g_thd.com = BLEND;
    g_thd.fn = fn_ble;
    g_thd.arg0.m0 = pm0;
    g_thd.arg1.m1 = pm1;
    g_thd.h = h1;
    g_thd.max_w = fpip->max_w * 2;
    
    LeaveCriticalSection(&g_cs);

    //1CƂɕʃXbhŏ
    blend_img[fn_ble](fpip->ycp_temp + fpip->max_w,
                      fpip->ycp_edit + fpip->max_w,
                      pm0 + fpip->max_w,
                      pm1 + fpip->max_w,
                      h0, fpip->max_w * 2, fpip->w);
    
    EnterCriticalSection(&g_cs);

    //I҂
    while(g_thd.com == BLEND){
      LeaveCriticalSection(&g_cs);
      Sleep(0);
      EnterCriticalSection(&g_cs);
    }
    
    SuspendThread(g_thr);
    
    if(fp->check[C_DISP]){
      //̕\
      disp_motion(fpip->ycp_temp, pm0, pm1, fp->check[C_MAX],
                  fpip->h, fpip->max_w, fpip->w);
    }
  }else{ //VOXbh or oȂ
    //LPF
    lpf_v[fn_lpf]( fpip->ycp_temp, fpip->ycp_edit,
                   fpip->h,
                   fp->track[T_TOP], fp->track[T_BTM],
                   fpip->max_w, fpip->w );
    
    //o
    if(fp->track[T_MTH] > 0){     
      pm0 = get_motion(fp, fpip);

      if(fp->check[C_BOTH]){
        //Ot[Ƃ̔r
        fn_ble = fp->check[C_MAX] + 1 + (fp->check[C_MMX] & g_sse) * 3;
        pm0 = g_tmp0;
        pm1 = g_tmp1;
      }else{
        //Õt[Ƃ̔r
        fn_ble = fp->check[C_MMX] * 3;
        pm1 = NULL;
      }

      //摜
      blend_img[fn_ble](fpip->ycp_temp, fpip->ycp_edit, pm0, pm1,
                        fpip->h, fpip->max_w, fpip->w);
      if(fp->check[C_DISP]){
        //̕\
        disp_motion(fpip->ycp_temp, pm0, pm1, fp->check[C_MAX],
                    fpip->h, fpip->max_w, fpip->w);
      }
    } // }else{ //VOXbh or oȂ
  }

  ycp = fpip->ycp_temp;
  fpip->ycp_temp = fpip->ycp_edit;
  fpip->ycp_edit = ycp;

  /*
  QueryPerformanceCounter(&g_ed);

  if(!fp->exfunc->is_saving(fpip->editp)){
    TCHAR buf[256];
    double d = g_ed.QuadPart - g_st.QuadPart;
    sprintf(buf, "%s CLK:%e", filter.name, d);
    SetWindowText(fp->hwnd, buf);
  }
   */
  
  return TRUE;
}

//---------------------------------------------------------------------
// SSEɑΉĂ邩`FbN
//---------------------------------------------------------------------
static int isSSEusable(void)
{
  long r_ecx,r_edx;

  // CPUIDɂ`FbN
  __asm {
    mov eax, 1
    cpuid
    mov r_edx, edx
    mov r_ecx, ecx
  }

  // MMX  0x0800000 edx
  // SSE  0x2000000 edx
  // SSE2 0x4000000 edx
  // SSE3 0x0000001 ecx
  r_edx &= 0x6800000;
  r_ecx &= 0x0000001;

  if(r_edx < 0x1000000)
    return 0;

  // OST|[gĂ邩
  __try {
    __asm xorps xmm0, xmm0
  }
  
  __except(EXCEPTION_EXECUTE_HANDLER){
    if (_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
      /* SSE not supported */
      return 0;
  }
  /* SSE are supported by OS */
  return 1;
}

//---------------------------------------------------------------------
// Xbh
//---------------------------------------------------------------------
unsigned __stdcall thProc(void * p)
{
  int loop = 1;
  thData *t = (thData *)p;
  
  while(loop){
    EnterCriticalSection(&g_cs);
    switch(t->com){
    case EXIT:
      loop = 0;
      break;
    case LPF:
      lpf_v[t->fn](t->dst, t->src,
                   t->h,
                   t->arg0.ht, t->arg1.hb,
                   t->max_w, t->w );
      t->com = WAIT;
      break;
    case BLEND:
      blend_img[t->fn](t->dst, t->src,
                       t->arg0.m0, t->arg1.m1,
                       t->h, t->max_w, t->w );
      t->com = WAIT;
      break;
    case WAIT:
    default:
      __asm pause
      break;
    }
    
    LeaveCriticalSection(&g_cs);
    Sleep(0);
  }

  _endthreadex(0);
  return 0;
}

//---------------------------------------------------------------------
// }XNւ̃|C^Ԃ
// n == 0 őÕt[Ƃ̔r n != 0 őOt[Ƃ̔r
//---------------------------------------------------------------------
short *get_motion(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *ycp;
  short *ret;
  const int fn_det = g_sse & fp->check[C_MMX];

  // g_tmp0 ɂ͋t[
  // g_tmp1 ɂ͊t[
  // ƂOt[Ƃ̓oʂLbVĂ
  if(g_tmp0_n == fpip->frame){
    ret = g_tmp0;
  }else if(g_tmp1_n == fpip->frame){
    ret = g_tmp1;
  }else{
    //LbVĂȂ
    if(fpip->frame&1){
      ret = g_tmp1;
      g_tmp1_n = fpip->frame;
    }else{
      ret = g_tmp0;
      g_tmp0_n = fpip->frame;
    }
    //fpip->ycp_editɌ݂̃t[Ă
    ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                 fpip->frame-1, NULL, NULL);
    detect_mov[fn_det](ycp, fpip->ycp_edit, ret,
                       fpip->h, fpip->max_w, fpip->w, fp->track[T_MTH]);
  }
  
  //Ot[Ƃ̔r
  if(fp->check[C_BOTH]){
    if(g_tmp0_n == fpip->frame+1){
      ret = g_tmp0;
    }else if(g_tmp1_n == fpip->frame+1){
      ret = g_tmp1;
    }else{
      //LbVĂȂ
      if(fpip->frame&1){
        ret = g_tmp0;
        g_tmp0_n = fpip->frame + 1;
      }else{
        ret = g_tmp1;
        g_tmp1_n = fpip->frame + 1;
      }
      ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                   fpip->frame+1, NULL, NULL);
      detect_mov[fn_det](ycp, fpip->ycp_edit, ret,
                         fpip->h, fpip->max_w, fpip->w, fp->track[T_MTH]);
    }
  }

  return ret;
}

